import java.lang.*;
import java.io.*;
import java.util.*;
import EDU.neu.ccs.demeter.*;
 class WebScript {
  protected Service_List service_list;
  public Service_List get_service_list() { return service_list;   }
  public void set_service_list(Service_List new_service_list) { service_list = new_service_list;   }
  public WebScript() { super();   }
  public WebScript(Service_List service_list) {
    super();
    set_service_list(service_list);
    }
  public static WebScript parse(java.io.Reader in) throws ParseException { return new Parser(in)._WebScript();   }
  public static WebScript parse(java.io.InputStream in) throws ParseException { return new Parser(in)._WebScript();   }
  public static WebScript parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
    }
   void print_all() {
    DisplayVisitor v0 = new DisplayVisitor();
    v0.start();
    all(v0);
    v0.finish();
    }
    void universal_trv0_bef(UniversalVisitor _v_) {
    _v_.before(this);
  }

    void universal_trv0_aft(UniversalVisitor _v_) {
    _v_.after(this);
  }

    void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    _v_.before_service_list(this, service_list);
    service_list.universal_trv0(_v_);
    _v_.after_service_list(this, service_list);
    universal_trv0_aft(_v_);
  }

    public void all(UniversalVisitor __v0) {
    all_WebScript_trv(__v0);
  }

    void all_WebScript_trv_bef(UniversalVisitor __v0) {
    __v0.before(this);
  }

    void all_WebScript_trv_aft(UniversalVisitor __v0) {
    __v0.after(this);
  }

    void all_WebScript_trv(UniversalVisitor __v0) {
    all_WebScript_trv_bef(__v0);
    __v0.before_service_list(this, service_list);
    service_list.all_WebScript_trv(__v0);
    __v0.after_service_list(this, service_list);
    all_WebScript_trv_aft(__v0);
  }

	  // method to execute the script
	  public void executeScript(PrintStream out)
	  {
			// get the elements within the list of Services
			Enumeration serviceList = get_service_list().elements();
			
			// loop through the list of of services
			// and execute them.
			while(serviceList.hasMoreElements())
				 {
					  // get an service from the service list
					  Service service = (Service) serviceList.nextElement();

					  // attempt to execute the service
					  service.executeService(out);  
				 }
			
	  }
	  
	  
	  
}
