import java.lang.*;
import java.io.*;
import java.util.*;
import EDU.neu.ccs.demeter.*;
 class Alternative extends Service {
  protected Service main;
  public Service get_main() { return main;   }
  public void set_main(Service new_main) { main = new_main;   }
  protected Service alternate;
  public Service get_alternate() { return alternate;   }
  public void set_alternate(Service new_alternate) { alternate = new_alternate;   }
  public Alternative() { super();   }
  public Alternative(Service main, Service alternate) {
    super();
    set_main(main);
    set_alternate(alternate);
    }
  public static Alternative parse(java.io.Reader in) throws ParseException { return new Parser(in)._Alternative();   }
  public static Alternative parse(java.io.InputStream in) throws ParseException { return new Parser(in)._Alternative();   }
  public static Alternative parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
    }
    void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
    _v_.before(this);
  }

    void universal_trv0_aft(UniversalVisitor _v_) {
    _v_.after(this);
    super.universal_trv0_aft(_v_);
  }

    void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    _v_.before_main(this, main);
    main.universal_trv0(_v_);
    _v_.after_main(this, main);
    _v_.before_alternate(this, alternate);
    alternate.universal_trv0(_v_);
    _v_.after_alternate(this, alternate);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

    void all_WebScript_trv_bef(UniversalVisitor __v0) {
    super.all_WebScript_trv_bef(__v0);
    __v0.before(this);
  }

    void all_WebScript_trv_aft(UniversalVisitor __v0) {
    __v0.after(this);
    super.all_WebScript_trv_aft(__v0);
  }

    void all_WebScript_trv(UniversalVisitor __v0) {
    all_WebScript_trv_bef(__v0);
    __v0.before_main(this, main);
    main.all_WebScript_trv(__v0);
    __v0.after_main(this, main);
    __v0.before_alternate(this, alternate);
    alternate.all_WebScript_trv(__v0);
    __v0.after_alternate(this, alternate);
    super.all_WebScript_trv(__v0);
    all_WebScript_trv_aft(__v0);
  }
	  
	  // the method that attempts to execute this service
	  public boolean executeService(PrintStream out)
	  {

			// if the main service failed then attempt the
			// alternate
			if (get_main().executeService(out) == false)
				 {
					  // if the execution of the alternate fails
					  // then return false
					  if (get_alternate().executeService(out) == false)
							return false;
				 }
			
			
			return true;
				
	  }
	  
}
