import java.lang.*;
import java.io.*;
import java.util.*;
import ServiceExecutorThread;
import ThreadMutex;



import EDU.neu.ccs.demeter.*;
 class Concurrent extends Service {
  protected Service service1;
  public Service get_service1() { return service1;   }
  public void set_service1(Service new_service1) { service1 = new_service1;   }
  protected Service service2;
  public Service get_service2() { return service2;   }
  public void set_service2(Service new_service2) { service2 = new_service2;   }
  public Concurrent() { super();   }
  public Concurrent(Service service1, Service service2) {
    super();
    set_service1(service1);
    set_service2(service2);
    }
  public static Concurrent parse(java.io.Reader in) throws ParseException { return new Parser(in)._Concurrent();   }
  public static Concurrent parse(java.io.InputStream in) throws ParseException { return new Parser(in)._Concurrent();   }
  public static Concurrent parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
    }
    void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
    _v_.before(this);
  }

    void universal_trv0_aft(UniversalVisitor _v_) {
    _v_.after(this);
    super.universal_trv0_aft(_v_);
  }

    void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    _v_.before_service1(this, service1);
    service1.universal_trv0(_v_);
    _v_.after_service1(this, service1);
    _v_.before_service2(this, service2);
    service2.universal_trv0(_v_);
    _v_.after_service2(this, service2);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

    void all_WebScript_trv_bef(UniversalVisitor __v0) {
    super.all_WebScript_trv_bef(__v0);
    __v0.before(this);
  }

    void all_WebScript_trv_aft(UniversalVisitor __v0) {
    __v0.after(this);
    super.all_WebScript_trv_aft(__v0);
  }

    void all_WebScript_trv(UniversalVisitor __v0) {
    all_WebScript_trv_bef(__v0);
    __v0.before_service1(this, service1);
    service1.all_WebScript_trv(__v0);
    __v0.after_service1(this, service1);
    __v0.before_service2(this, service2);
    service2.all_WebScript_trv(__v0);
    __v0.after_service2(this, service2);
    super.all_WebScript_trv(__v0);
    all_WebScript_trv_aft(__v0);
  }
	  
	  // the method that attempts to execute ths service
	  public boolean executeService(PrintStream out)
	  {
			ThreadMutex mutex = new ThreadMutex(2, out);
			
			
			// spawn off 2 thread to execute the 2 services
			// and then wait for them.
			ServiceExecutorThread thread1 =
				 new ServiceExecutorThread(service1, mutex);
			ServiceExecutorThread thread2 =
				 new ServiceExecutorThread(service2, mutex);

			thread1.run();
			thread2.run();

			mutex.waitForThreads();

			if (thread1.getReturnStatus() &&
				 thread2.getReturnStatus())
				 return true;
			else
				 return false;
				
	  }
	  
}
